#include <stdio.h>
#include <math.h>

#define FALSE         0
#define TRUE  (! FALSE)
#define MAXMAT      10
/* code will handle up to a MAXMAT square array, 
   but it does not have to use complete space*/

struct matrix { double M[MAXMAT][MAXMAT];
				int rows;
				int cols; 
};

/* used for right side and solution in Ax=B */
struct matrix_column { double M[MAXMAT];
					   int rows;
};

double                     sqr(double invalue);

struct matrix        transpose(struct matrix matrix_in);

struct matrix  matrix_multiply(struct matrix matrix1,
							   struct matrix matrix2);

struct matrix          adjoint(struct matrix matrix_in);

struct matrix          inverse(struct matrix matrix_in);

double                   trace(struct matrix matrix_in);

double                cofactor(struct matrix matrix_in,
							   int           row_pos,
							   int           col_pos);

double                     det(struct matrix matrix_in);

double                   minor(struct matrix matrix_in,
							   int           row_pos,
							   int           col_pos);

int               print_matrix(FILE          *output,
							   struct matrix matrix_in);
int        print_matrix_column(FILE          *output,
							   struct matrix_column matrix_in);

struct matrix_column  solution(FILE      *output,
							   struct matrix matrix_A,
							   struct matrix_column matrix_B);