#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <io.h>
#include <dos.h>
#include <conio.h>
#include "matrix_lib.h"

void main(int argc,char *argv[])
{
  FILE          *output;
  struct matrix A,X,AtimesX;
  struct matrix_column B,sol;
  int row;

  /* ------ Matrix Subroutines Test ------- */
  /* output = fopen("MAT_TEST.TXT","w"); */
  output = stderr;

  A.M[0][0] = 0.0;
  A.M[0][1] = 2.4;
  A.M[0][2] = 3.5; 
  A.M[0][3] = 5.3;
  A.M[1][0] = 0.0;
  A.M[1][1] = 5.8;
  A.M[1][2] = 6.3;
  A.M[1][3] = 0.0;
  A.M[2][0] = 0.0;
  A.M[2][1] = 8.9;
  A.M[2][2] = 9.4;
  A.M[2][3] = 10.5;
  A.M[3][0] = 0.0;
  A.M[3][1] = 0.0;
  A.M[3][2] = 8.4;
  A.M[3][3] = 1.5;
  A.rows = 4;
  A.cols = 4;

  fprintf(output,"A matrix:\n");
  print_matrix(output,A);

  fprintf(output,"|A| (Determinate of A) = %15.5f\n",det(A));

  fprintf(output,"Adjoint of A matrix:\n");
  print_matrix(output,adjoint(A));

  fprintf(output,"Transpose of A matrix:\n");
  print_matrix(output,transpose(A));

  fprintf(output,"Inverse of A matrix :\n");
  print_matrix(output,inverse(A));

  fprintf(output,"A matrix (x) inverse A matrix:\n");
  print_matrix(output,matrix_multiply(A,inverse(A)));

  fprintf(output,"\nSystem of equations example:\n------------------------\n");

  X.M[0][0] = 1.2;
  X.M[1][0] = 2.6;
  X.M[2][0] = 3.9;
  X.M[3][0] = 6.2;
  X.rows = 4;
  X.cols = 1;

  fprintf(output,"X matrix:\n");
  print_matrix(output,X);

  AtimesX = matrix_multiply(A,X);

  fprintf(output,"A matrix (x) X matrix:\n");
  print_matrix(output,AtimesX);

  /* put AtimesX (2 dimensional array) into B (1 dimensional array) for system of equations example */
  B.rows = X.rows;
  for (row=0;row<B.rows;row++)
	  B.M[row]=AtimesX.M[row][0];

  fprintf(output,"A matrix (x) X matrix = B matrix:\n");
  print_matrix_column(output,B);

  fprintf(output,"\nNow go the other way; using A and B, solve for X...\n");
  sol=solution(output,A,B);

  fprintf(output,"\nX matrix (solved for - should match original X matrix definition):\n");
  print_matrix_column(output,sol);

  fclose(output);

  printf("Program done.\n");
}
